/*! node-ati 2021-07-29 */

var _=require("lodash"),fs=require("fs"),Spot=require("./spot.js"),System=require("./../lib/openwrt/system.ts.js").Factory.create(),Datafile=require("./../lib/utils/datafile.js"),config=require("./../config.js");function Spots(t,e){var o=this;if(this._initialized=void 0,this._items=[],this._dataFileName="./data/spots.json",this._dataFileNameLocal="./data/spots.local.json",this._settings=e,this._channelColors=null,this.maxLocalTemperature=0,this._checkTimeoutInterval=setInterval(function(){o._onCheckTimeoutInterval()},5e3),this._checkPowerInterval=setInterval(function(){o._onCheckPowerInterval()},3e5),void 0!==t)for(var o=this,n=0;n<t.length;n++)o.add(new Spot(t[n]))}Spots.prototype.Initialized=function(){return void 0===this._initialized&&(this._initialized=fs.existsSync(this._dataFileName)),this._initialized},Spots.prototype.add=function(t){_.some(this._items)&&(t._id=_.last(this._items)._id+1),void 0===t.externalId&&(t.externalId=this._createExternalId(t._id)),void 0===this.findByExternalId(t.externalId)&&this._items.push(t)},Spots.prototype.findById=function(e){return _.find(this._items,function(t){return t._id==e})},Spots.prototype.findByExternalId=function(e){return _.find(this._items,function(t){return t.externalId===e})},Spots.prototype.removeById=function(e){_.remove(this._items,function(t){return t._id==e})},Spots.prototype.save=function(){var t=this.getRawData();Datafile.writeData(t,this._dataFileName),this._initialized=!0},Spots.prototype.addExternalItems=function(t){var e=this;_.forEach(t.spots,function(t){void 0!==t.externalId&&void 0===_.find(e._items,{externalId:t.externalId})&&(console.log("add spot ",t.externalId),e.add(new Spot(t)))})},Spots.prototype.getOwnItems=function(){return _.filter(this._items,function(t){return t.isLocal()})},Spots.prototype.getItems=function(t){return this._items},Spots.prototype.getChannelColors=function(){if(null!==this._channelColors)return this._channelColors;var e={},o=[],n=0;return _.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){o.push({id:n++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort})}),this._channelColors=o,this._channelColors},Spots.prototype.load=function(){this._load(this._dataFileName),fs.existsSync(this._dataFileNameLocal)||Datafile.writeData(this._getRawData(this.getOwnItems()),this._dataFileNameLocal),this._load(this._dataFileNameLocal,!1)},Spots.prototype._load=function(t,e){var o=Datafile.readData(t);if(void 0!==o){!1!==e&&(this._items=[]);for(var n=0;n<o.length;n++)this.add(new Spot(o[n]))}},Spots.prototype.getRawData=function(){return this._getRawData(_.filter(this._items,function(t){return-1!==_.parseInt(t._id)}))},Spots.prototype._getRawData=function(t){t=_.cloneDeep(t,!0);return t=_.map(t,function(t){return t.temperature=void 0,t.temperatureInvalid=void 0,t.lastOnlineUpdate=void 0,t.online=void 0,t.power=void 0,t._colorChannels=void 0,t})},Spots.prototype.updateLocalTemperature=function(n){var r=!1,a=0;_.forEach(this._items,function(t){return!t.isLocal()||(!r&&void 0!==_.find(t.channels,{address:n.address})&&n.value<150&&(e=Math.round(10*n.value)/10,void 0===t.rawtemperature&&(t.rawtemperature=[]),void 0===(o=_.find(t.rawtemperature,function(t){return t.addr===n.address}))&&(o={value:e,addr:n.address},t.rawtemperature.push(o)),o.value=e,t.lastOnlineUpdate=Date.now(),t.online=!0,t.temperature=_.maxBy(t.rawtemperature,"value").value,r=!0),void(t.temperature>a&&(a=t.temperature)));var e,o}),this.maxLocalTemperature=a},Spots.prototype.removeExternalItems=function(){this._items=_.remove(this._items,function(t){return!t.isLocal()})},Spots.prototype.removeByExternalId=function(e){this._items=_.remove(this._items,function(t){return!(t.isPartOfExternalId(e)&&!t.isLocal())})},Spots.prototype.updateOnlineState=function(t){var e=t.request.id,o=!1;return _.forEach(this._items,function(t){t.isPartOfExternalId(e)&&(t.lastOnlineUpdate=Date.now(),t.online=!0,o=!0)}),o},Spots.prototype._onCheckTimeoutInterval=function(){_.forEach(this._items,function(t){t.lastOnlineUpdate<Date.now()-(t.isLocal()?12e4:25e3)&&(t.online=!1)})},Spots.prototype._onCheckPowerInterval=function(){_.forEach(this._items,function(t){t.updatePower()})},Spots.prototype.updateExternalTemperature=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){return!!t.isLocal()||(t.externalId===e.externalId?(t.temperature=e.temperature,t.rawtemperature=e.rawtemperature,!1):void 0)})})},Spots.prototype.getTemperatures=function(){var e=[];return _.forEach(this._items,function(t){e.push({externalId:t.externalId,temperature:t.temperature})}),e},Spots.prototype.setTemperatures=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){if(t.externalId===e.externalId)return t.temperature=e.temperature,!1})})},Spots.prototype.getChannelColors=function(){if(null!==this._channelColors)return this._channelColors;var e={},a=[],i=0;return _.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){var o,n=1,r=void 0;void 0===config.colorFactors||void 0!==(o=_.find(config.colorFactors,{name:t.name}))&&(n=o.factor),void 0!==config.colorReduceTemperatures&&(r=_.find(config.colorReduceTemperatures,{name:t.name})),a.push({id:i++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort,factor:n,valueTemperature:r})}),this._channelColors=a,this._channelColors},Spots.prototype._createExternalId=function(t){return System.getId()+":"+t},module.exports=Spots;